﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Infragistics.Controls.Charts;

namespace xamDataChartDateAxis
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
      
            var Trades = new ObservableCollection<LiveViewDataPoint>();

            Trades.Add(new LiveViewDataPoint() { Date =  DateTime.Now, Price = 25.68 });
            Trades.Add(new LiveViewDataPoint() { Date = DateTime.Now.AddDays(1), Price = 5.68 });
            Trades.Add(new LiveViewDataPoint() { Date = DateTime.Now.AddDays(2), Price = 45.56 });
            Trades.Add(new LiveViewDataPoint() { Date = DateTime.Now.AddDays(3), Price = 125.68 });
            Trades.Add(new LiveViewDataPoint() { Date = DateTime.Now.AddDays(5), Price = 125.68 });
            Trades.Add(new LiveViewDataPoint() { Date = DateTime.Now.AddDays(5), Price = 35.68 });
            Trades.Add(new LiveViewDataPoint() { Date = DateTime.Now.AddDays(6), Price = 345.56 });
            Trades.Add(new LiveViewDataPoint() { Date = DateTime.Now.AddDays(7), Price = 125.68 });
            Trades.Add(new LiveViewDataPoint() { Date = DateTime.Now.AddDays(7), Price = 56.68 });
            Trades.Add(new LiveViewDataPoint() { Date = DateTime.Now.AddDays(7), Price = 15.68 });
            Trades.Add(new LiveViewDataPoint() { Date = DateTime.Now.AddDays(11), Price = 145.56 });
            Trades.Add(new LiveViewDataPoint() { Date = DateTime.Now.AddDays(11), Price = 135.68 });

            this.xamChart1.DataContext = Trades;
        }

        private void Series_MouseWheel(object sender, MouseWheelEventArgs e)
        {
            e.Handled = true;
        }

        void border_MouseWheel(object sender, MouseWheelEventArgs e)
        {
            e.Handled = true;
        }   

        private T GetChildFromType<T>(DependencyObject parent) where T : DependencyObject
        {
            T result = null;

            for (int i = 0; i < VisualTreeHelper.GetChildrenCount(parent); i++)
            {
                if (VisualTreeHelper.GetChild(parent, i) is T)
                {
                    return VisualTreeHelper.GetChild(parent, i) as T;
                }
                else
                {
                    result = GetChildFromType<T>(VisualTreeHelper.GetChild(parent, i));

                    if (result != null)
                    {
                        break;
                    }
                }
            }
            return result;
        }

        private void xamChart1_RefreshCompleted(object sender, EventArgs e)
        {
            ContentPresenter cp = GetChildFromType<ContentPresenter>(xamChart1) as ContentPresenter;
            Border border = GetChildFromType<Border>(cp) as Border;
            (border.Child as Grid).Children.Add(new Canvas() { Background = new SolidColorBrush(Colors.Transparent) });
            (border.Child as Grid).Children.Last().MouseWheel += border_MouseWheel;     
        }        
    }

    public class LiveViewDataPoint
    {
        public DateTime Date { get; set; }
        public double Price { get; set; }
    }
}
